#include "config.h"
#include "exc.h"

wt_exception libwtref_exc_IOException;
wt_exception libwtref_exc_EndOfFileException;

wt_error libwtref_get_exceptions(struct wtr_vm* const vm,
	LIBWTREF_PFN_ERROR_CB errcb, void* errcb_priv)
{
	wt_error err;

	if(WTE_OK!=(err=wtrVMGetException(vm, "IOException",
		&libwtref_exc_IOException)))
	{
		errcb(errcb_priv, "Could not get IOException", err);
		return err;
	}

	if(WTE_OK!=(err=wtrVMGetException(vm, "EndOfFileException",
		&libwtref_exc_EndOfFileException)))
	{
		errcb(errcb_priv, "Could not get IOException", err);
		return err;
	}

	return WTE_OK;
}
