#include <stdio.h>
#include <string.h>
#include "arg.h"
#include "log.h"
#include "dep.h"
#include "db.h"
#include "tmpasm_scconfig.h"

static void libwtref_set_debug(const char* val)
{
	put("/local/libwtref/debug", val);
}

static void libwtref_set_prefix(const char* val)
{
	put("/local/libwtref/prefix", val);
}

static void libwtref_hook_postinit(void)
{
	db_mkdir("/local");
	put("/local/libwtref/debug", sfalse);
	put("/local/libwtref/prefix", "/usr");
}

static int libwtref_hook_detect_host(void)
{
	return 0;
}

static int libwtref_hook_detect_target(void)
{
	require("sys/ext_exe", 0, 0);
	require("cc/fpic", 0, 0);
	require("cc/wlrpath", 0, 0);
	require("cc/argstd/*", 0, 0);
	require("cc/cc", 0, 0);
	require("cc/cflags", 0, 0);
	require("libs/errno/*", 0, 0);
	require("libs/fs/access/*", 0, 0);
	require("libs/fs/access/macros/*", 0, 0);
	require("libs/fs/stat/fields/*", 0, 0);
	require("libs/fs/stat/macros/*", 0, 0);
	require("libs/fs/readdir/*", 0, 0);
	require("libs/fs/findnextfile/*", 0, 0);
	require("libs/io/fileno/*", 0, 0);
	require("libs/io/lseek/*", 0, 0);

	return 0;
}

static int libwtref_hook_generate(const char* root)
{
	int generr = 0;

	fprintf(stderr, "Generating libwtref/Makefile (%d)\n", generr |= tmpasm(root, "Makefile.in", "Makefile"));
	fprintf(stderr, "Generating libwtref/config.h (%d)\n", generr |= tmpasm(root, "config.h.in", "config.h"));

	return generr;
}
