#ifndef READWTB_FLAGBUILDER_H
#define READWTB_FLAGBUILDER_H

#include "welltype/wtruntime.h"

struct FlagBuilder;


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/* 'none_replacement' is a replacement string if the the parser got no flags. */
/* This is optional, but if NULL is specified, it will be an empty string. */
struct FlagBuilder* FlagBuilder_Create(const char* const none_replacement);

void FlagBuilder_Release(struct FlagBuilder* const builder);
int FlagBuilder_Add(struct FlagBuilder* const builder, wt_u64 flag, const char* const str);

/* Convert flags into a string. */
/* Returns 'buf' on success; NULL otherwise. */
/* The parser writes at most 'size' number of characters into 'buf'. */
char* FlagBuilder_Parse(struct FlagBuilder* const builder, wt_u64 flags, char* buf, size_t size);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* READWTB_FLAGBUILDER_H */
