//================================================================================================
// $Id: debugger.h 6309 2023-01-16 20:19:42Z aron $
//
// Project:
//		Welltype Parser
// Contents:
//		Debugger helper
// Authors:
//		Aron Barath, 2014-2023
//================================================================================================
// Copyright (c) Aron Barath
//================================================================================================

#ifndef WTPARSER_DEBUGGER_H
#define WTPARSER_DEBUGGER_H

#include <iostream>
#include <iomanip>

template<bool Enabled>
class Debugger
{
public:
	Debugger(bool) { }
	void PrintRule(const char*) { }
	void PrintLex(int token, const char* value) { }
};

template<>
class Debugger<true>
{
	bool enabled;
public:
	Debugger(bool en) : enabled(en)
	{
		// ok
	}

	void PrintRule(const char* message)
	{
		if(enabled)
		{
			std::cout << message << std::endl;
		}
	}

	void PrintLex(int token, const char* value)
	{
		if(enabled)
		{
			if((-1)==token)
			{
				std::cout << "LEXER EOF" << std::endl;
			}
			else
			{
				std::cout << "LEXER "
					/*<< std::hex << std::setw(4) << std::setfill('0')*/ << static_cast<unsigned int>(token)
					//<< std::dec << std::setw(0)
					<< ": " << (value?value:"")
					<< std::endl;
			}
		}
	}
};

#endif // WTPARSER_DEBUGGER_H

